/****************************************************************************************
 *
 * ENABLE/DISABLE FORM ELEMENTS ( FOR HIDDEN UI ELEMENTS )
\********************************************************************************************/
vsb_disable_form_elements_for_node = function(collection){
    $(collection).each(function(){
        var _node = $(this);
        _node.find(':input').each(function(){
            if($(this).data("disabled-by-node") === undefined || $(this).data("disabled-by-node") == null ){
                $(this).data("disabled-by-node", _node);
                $(this).attr("disabled", true);
            } else {
                if (_node.parents($(this).data("disabled-by-node")).length!=0){
                    $(this).data("disabled-by-node", _node);
                }
            }
        });
    });
};


vsb_enable_form_elements_for_node = function(collection){
    $(collection).each(function(){
        var _node = $(this);
        _node.find(':input').each(function(){
            if(_node.is($(this).data("disabled-by-node"))){
                $(this).data("disabled-by-node",null);
                $(this).attr("disabled", false);
                if (typeof CKEDITOR != 'undefined') {
                    if (CKEDITOR.instances[$(this).attr('id')]) {
                        var _config =CKEDITOR.instances[$(this).attr('id')].config;
                        CKEDITOR.instances[$(this).attr('id')].destroy();
                        CKEDITOR.replace(this,_config);
                    }
                }
            }
        });
    });
};

/****************************************************************************************
 *
 * JQPLOT
 \********************************************************************************************/
var _vsb_jqplot_registry = {}; // this is because jqplot is crap and i have no time to explain further
vsb_init_page_load_chain.push(function(document){
    $(document).find('div[data-role="vsb-jqplot"]').each(function() {
        var options = $(this).data('options');
        // renderer options are JS objects
        // they must be eval'd
        if (options.axesDefaults &&
            typeof(options.axesDefaults.renderer) === 'string' &&
            options.axesDefaults.renderer.indexOf('$.') === 0) {
            options.axesDefaults.renderer = eval(options.axesDefaults.renderer)
        }
        if (options.axes) {
            if(options.axes.xaxis) {
                if(typeof(options.axes.xaxis.tickRenderer) === 'string' && options.axes.xaxis.tickRenderer.indexOf('$.') === 0) {
                    options.axes.xaxis.tickRenderer = eval(options.axes.xaxis.tickRenderer)
                }
                if(typeof(options.axes.xaxis.renderer) === 'string' && options.axes.xaxis.renderer.indexOf('$.') === 0) {
                    options.axes.xaxis.renderer = eval(options.axes.xaxis.renderer)
                }
            }
            if(options.axes.yaxis) {
                if(typeof(options.axes.yaxis.tickRenderer) === 'string' && options.axes.yaxis.tickRenderer.indexOf('$.') === 0) {
                    options.axes.yaxis.tickRenderer = eval(options.axes.yaxis.tickRenderer)
                }
                if(typeof(options.axes.yaxis.renderer) === 'string' && options.axes.yaxis.renderer.indexOf('$.') === 0) {
                    options.axes.yaxis.renderer = eval(options.axes.yaxis.renderer)
                }
            }
            if(options.axes.x2axis) {
                if(typeof(options.axes.x2axis.tickRenderer) === 'string' && options.axes.x2axis.tickRenderer.indexOf('$.') === 0) {
                    options.axes.x2axis.tickRenderer = eval(options.axes.x2axis.tickRenderer)
                }
                if(typeof(options.axes.x2axis.renderer) === 'string' && options.axes.x2axis.renderer.indexOf('$.') === 0) {
                    options.axes.x2axis.renderer = eval(options.axes.x2axis.renderer)
                }
            }
            if(options.axes.y2axis) {
                if(typeof(options.axes.y2axis.tickRenderer) === 'string' && options.axes.y2axis.tickRenderer.indexOf('$.') === 0) {
                    options.axes.y2axis.tickRenderer = eval(options.axes.y2axis.tickRenderer)
                }
                if(typeof(options.axes.y2axis.renderer) === 'string' && options.axes.y2axis.renderer.indexOf('$.') === 0) {
                    options.axes.y2axis.renderer = eval(options.axes.y2axis.renderer)
                }
            }
        }
        if (options.seriesDefaults) {
            if (typeof(options.seriesDefaults.renderer) === 'string' && options.seriesDefaults.renderer.indexOf('$.') === 0) {
                options.seriesDefaults.renderer = eval(options.seriesDefaults.renderer)
            }
            if (typeof(options.seriesDefaults.markerRenderer) === 'string' && options.seriesDefaults.markerRenderer.indexOf('$.') === 0) {
                options.seriesDefaults.markerRenderer = eval(options.seriesDefaults.markerRenderer)
            }
        }
        if (options.series) {
            for(var i = 0, length = options.series.length; i < length; i++) {
                if (typeof(options.series[i].renderer) === 'string' && options.series[i].renderer.indexOf('$.') === 0) {
                    options.series[i].renderer = eval(options.series[i].renderer)
                }
                if (typeof(options.series[i].markerRenderer) === 'string' && options.series[i].markerRenderer.indexOf('$.') === 0) {
                    options.series[i].markerRenderer = eval(options.series[i].markerRenderer)
                }
            }
        }
        if (options.legend &&
            typeof(options.legend.renderer) === 'string' &&
            options.legend.renderer.indexOf('$.') === 0) {
            options.legend.renderer = eval(options.legend.renderer)
        }

        // initialize the graph
        $(this).empty();
        _vsb_jqplot_registry[$(this).attr('id')] = $.jqplot($(this).attr('id'), $(this).data('series'), options);
    });
});

vsb_init_dynamic_content_chain.push(function(content){
    $(content).find('div[data-role="vsb-jqplot"]').each(function() {
        var options = $(this).data('options');
        // renderer options are JS objects
        // they must be eval'd
        if (options.axesDefaults &&
            typeof(options.axesDefaults.renderer) === 'string' &&
            options.axesDefaults.renderer.indexOf('$.') === 0) {
            options.axesDefaults.renderer = eval(options.axesDefaults.renderer)
        }
        if (options.axes) {
            if(options.axes.xaxis) {
                if(typeof(options.axes.xaxis.tickRenderer) === 'string' && options.axes.xaxis.tickRenderer.indexOf('$.') === 0) {
                    options.axes.xaxis.tickRenderer = eval(options.axes.xaxis.tickRenderer)
                }
                if(typeof(options.axes.xaxis.renderer) === 'string' && options.axes.xaxis.renderer.indexOf('$.') === 0) {
                    options.axes.xaxis.renderer = eval(options.axes.xaxis.renderer)
                }
            }
            if(options.axes.yaxis) {
                if(typeof(options.axes.yaxis.tickRenderer) === 'string' && options.axes.yaxis.tickRenderer.indexOf('$.') === 0) {
                    options.axes.yaxis.tickRenderer = eval(options.axes.yaxis.tickRenderer)
                }
                if(typeof(options.axes.yaxis.renderer) === 'string' && options.axes.yaxis.renderer.indexOf('$.') === 0) {
                    options.axes.yaxis.renderer = eval(options.axes.yaxis.renderer)
                }
            }
            if(options.axes.x2axis) {
                if(typeof(options.axes.x2axis.tickRenderer) === 'string' && options.axes.x2axis.tickRenderer.indexOf('$.') === 0) {
                    options.axes.x2axis.tickRenderer = eval(options.axes.x2axis.tickRenderer)
                }
                if(typeof(options.axes.x2axis.renderer) === 'string' && options.axes.x2axis.renderer.indexOf('$.') === 0) {
                    options.axes.x2axis.renderer = eval(options.axes.x2axis.renderer)
                }
            }
            if(options.axes.y2axis) {
                if(typeof(options.axes.y2axis.tickRenderer) === 'string' && options.axes.y2axis.tickRenderer.indexOf('$.') === 0) {
                    options.axes.y2axis.tickRenderer = eval(options.axes.y2axis.tickRenderer)
                }
                if(typeof(options.axes.y2axis.renderer) === 'string' && options.axes.y2axis.renderer.indexOf('$.') === 0) {
                    options.axes.y2axis.renderer = eval(options.axes.y2axis.renderer)
                }
            }
        }
        if (options.seriesDefaults) {
            if (typeof(options.seriesDefaults.renderer) === 'string' && options.seriesDefaults.renderer.indexOf('$.') === 0) {
                options.seriesDefaults.renderer = eval(options.seriesDefaults.renderer)
            }
            if (typeof(options.seriesDefaults.markerRenderer) === 'string' && options.seriesDefaults.markerRenderer.indexOf('$.') === 0) {
                options.seriesDefaults.markerRenderer = eval(options.seriesDefaults.markerRenderer)
            }
        }
        if (options.series) {
            for(var i = 0, length = options.series.length; i < length; i++) {
                if (typeof(options.series[i].renderer) === 'string' && options.series[i].renderer.indexOf('$.') === 0) {
                    options.series[i].renderer = eval(options.series[i].renderer)
                }
                if (typeof(options.series[i].markerRenderer) === 'string' && options.series[i].markerRenderer.indexOf('$.') === 0) {
                    options.series[i].markerRenderer = eval(options.series[i].markerRenderer)
                }
            }
        }
        if (options.legend &&
            typeof(options.legend.renderer) === 'string' &&
            options.legend.renderer.indexOf('$.') === 0) {
            options.legend.renderer = eval(options.legend.renderer)
        }

        // initialize the graph

        $(this).empty();
        _vsb_jqplot_registry[$(this).attr('id')] = $.jqplot($(this).attr('id'), $(this).data('series'), options);

    });
});

/***************************************************************************************
 * LOADING BUTTON FOR SYNCHRONOUS REQUESTS
 \********************************************************************************************/
vsb_init_page_load_chain.push(function(document){
    $(document).on("click", 'form.animate-loading button[type="submit"]', function (e) {
        $('#loading-overlay').show();
    });
});

vsb_init_dynamic_content_chain.push(function(content){
});

/***************************************************************************************
 * JS SUBMIT FORMS
 \********************************************************************************************/
vsb_init_page_load_chain.push(function(document){
    $(document).on("click", '[data-action="form-submit"]', function (e) {
        $($(this).data('target')).submit()
    });
});

vsb_init_dynamic_content_chain.push(function(content){
});


/********************************************************************************************\
 *
 * BOOTSTRAP POPOVER
 *
 \********************************************************************************************/
vsb_init_page_load_chain.push(function(document){
    // noop
});

vsb_init_dynamic_content_chain.push(function(content){
    $(content).find('[data-toggle="popover"]').popover();
});

/********************************************************************************************\
 *
 * BOOTSTRAP MODAL
 *
 \********************************************************************************************/
vsb_init_page_load_chain.push(function(document){
    // noop
});

vsb_init_dynamic_content_chain.push(function(content){
    $(content).find('[data-toggle="modal"]').modal({
        show: false
    });
});

/********************************************************************************************\
 *
 * SELECT PICKER
 *
 \********************************************************************************************/
vsb_init_page_load_chain.push(function(document){
    // noop
});

vsb_init_dynamic_content_chain.push(function(content){
    $(content).find('.selectpicker').selectpicker();
});

/********************************************************************************************\
 *
 * CKEditor
 *
 \********************************************************************************************/
// CKEditor instances are initalized by the cktext_area form_helper.

/********************************************************************************************\
 *
 * DATE PICKER
 *
\********************************************************************************************/
vsb_init_page_load_chain.push(function(document){
    // EVENT update the hidden field with the new date whenever the user changes the datepicker using the calendar popup

    // datepicker class set on INPUT_GROUP
    $(document).on("dp.change",'.input-group.datepicker', function(e){
        if(e.date){
            $(this).find('input[type=hidden]').val(e.date.format());
        } else {
            $(this).find('input[type=hidden]').val('');
        }
        //  link pickers: set max min dates every time a new value is selected
        if(typeof $(this).attr('data-restrict-max') !== 'undefined' ) {
            var _other_picker = $($(this).attr('data-restrict-max'));
            if(typeof _other_picker.data("DateTimePicker")!== 'undefined' && typeof $(this).data("DateTimePicker") !== 'undefined'){
                _other_picker.data("DateTimePicker").maxDate($(this).data("DateTimePicker").date());
            }
        }
        if(typeof $(this).attr('data-restrict-min') !== 'undefined') {
            var _other_picker = $($(this).attr('data-restrict-min'));
            if(typeof _other_picker.data("DateTimePicker")!== 'undefined'  && typeof $(this).data("DateTimePicker") !== 'undefined'){
                _other_picker.data("DateTimePicker").minDate($(this).data("DateTimePicker").date());
            }
        }
    });
    // datepicker class set on actual INPUT
    $(document).on("dp.change", 'input.datepicker', function (e) {
        if(e.date){
            $(this).parent().find('input[type=hidden]').val(e.date.format());
        } else {
            $(this).parent().find('input[type=hidden]').val('');
        }
        //  link pickers: set max min dates every time a new value is selected
        if(typeof $(this).attr('data-restrict-max') !== 'undefined' ) {
            var _other_picker = $($(this).attr('data-restrict-max'));
            if(typeof _other_picker.data("DateTimePicker")!== 'undefined' && typeof $(this).data("DateTimePicker") !== 'undefined'){
                _other_picker.data("DateTimePicker").maxDate($(this).data("DateTimePicker").date());
            }
        }
        if(typeof $(this).attr('data-restrict-min') !== 'undefined') {
            var _other_picker = $($(this).attr('data-restrict-min'));
            if(typeof _other_picker.data("DateTimePicker")!== 'undefined'  && typeof $(this).data("DateTimePicker") !== 'undefined'){
                _other_picker.data("DateTimePicker").minDate($(this).data("DateTimePicker").date());
            }
        }
    });

    // EVENT reset the hidden field when the user left the datepicker input field empty
    $(document).on("change", '.input-group.datepicker', function (e) {
        var _val = $( this ).find('input').not( '[type=hidden]' ).val();
        if(_val==null||_val==undefined||_val==''){
            $(this).find('input[type=hidden]').val(null);
        }
    });
    $(document).on("change", 'input.datepicker', function (e) {
        var _val = $( this ).val();
        if(_val==null||_val==undefined||_val==''){
            $(this).parent().find('input[type=hidden]').val(null);
        }
    });
});

vsb_init_dynamic_content_chain.push(function(content){


    $(content).find('.datepicker').each(function(){
        var _options = {}; var _defaults = $([
            // data-attribute, option key, default value
            ['data-locale','locale','de'],
            ['data-format','format','L'],
            ['data-min-date','minDate',false],
            ['data-max-date','maxDate',false],
            ['data-disabled-dates','disabledDates',[]],
            ['data-allow-input-toggle','allowInputToggle',true]
        ]);

        if(typeof $(this).attr('data-restrict-min') !== 'undefined') {
            _defaults.push(['data-use-current','useCurrent',false]);
        }
        for (var i = 0; i < _defaults.length; i++) {
            if(_defaults[i][1] == 'minDate' || _defaults[i][1] == 'maxDate'){
                _options[_defaults[i][1]] = (typeof $(this).attr(_defaults[i][0]) === 'undefined' ? _defaults[i][2] : $(this).attr(_defaults[i][0]))
            } else {
                _options[_defaults[i][1]] = (typeof $(this).attr(_defaults[i][0]) === 'undefined' ? _defaults[i][2] : $.parseJSON($(this).attr(_defaults[i][0])))
            }
        }
        $(this).datetimepicker(_options);
        if($(this).hasClass('.input-group')){
            var _before = $(this).find('input[type=hidden]').val()
        } else {
            var _before = $(this).parent().find('input[type=hidden]').val()
        }
        // get value from hidden field sibling
        if($(this).hasClass('.input-group')){
            $(this).data("DateTimePicker").date(moment(_before));
        } else {
            $(this).data("DateTimePicker").date(moment(_before));
        }
    });
    //  link pickers: set initial max min dates
    $(content).find('.datepicker').each(function(){
        // data-restrict-min (contains selector) means: set the selected pickers min date to the current date of this picker
        if(typeof $(this).attr('data-restrict-min') !== 'undefined') {
            var _other_picker = $($(this).attr('data-restrict-min'));
            _other_picker.data("DateTimePicker").minDate($(this).data("DateTimePicker").date());
        }
        // data-restrict-max (contains selector) means: set the selected pickers max date to the current date of this picker
        if(typeof $(this).attr('data-restrict-max') !== 'undefined' ) {
            var _other_picker = $($(this).attr('data-restrict-max'));
            _other_picker.data("DateTimePicker").maxDate($(this).data("DateTimePicker").date());
        }
    });
});


/********************************************************************************************\
 *
 * CLIENT SIDE CLASSIC PAGER  (full request for every page)
 *
 \********************************************************************************************/
vsb_init_page_load_chain.push(function(document){
    // noop
});
vsb_init_dynamic_content_chain.push(function(content){
    var queryParameters = {}, queryString = location.search.substring(1), re = /([^&=]+)=([^&]*)/g, m;
    while (m = re.exec(queryString)) {
        queryParameters[decodeURIComponent(m[1])] = decodeURIComponent(m[2]);
    }
    $(content).find('.pagination-control').each(function(){
        var _pagination_control = $(this);
        var _page_param = _pagination_control.data('page-param');
        if(_page_param===undefined){
            _page_param = 'page'
        }
        _pagination_control.jqPagination({
            'page_string': '{current_page} von {max_page}',
            'max_page': _pagination_control.data('max-page'),
            'link_string': _page_param,
            //'current_page': queryParameters[_page_param],
            paged: function(page) {
                if (queryParameters[_page_param] != page) {
                    queryParameters[_page_param] = page;
                    location.search = $.param(queryParameters);
                }
            }
        });
        // Ticket #258 pager did not set current page correctly (i.e. on page 2, but pager shows page 1 in input field )
        _pagination_control.jqPagination('option', 'current_page', queryParameters[_page_param])
    });
});
/********************************************************************************************\
 *
 * CLIENT SIDE JS PAGER (all items loaded)
 *
\********************************************************************************************/
vsb_init_page_load_chain.push(function(document){
    // noop
});

vsb_init_dynamic_content_chain.push(function(content){
    // INIT enable pagers
    $(content).find('.pager-control').each(function(i){
        var _pager_control = $(this);
        var _pager_control_input = _pager_control.find('input[data-current-page]');
        var _target = $(_pager_control.data('target'));
        /*var _hash = location.hash.substring(1);
        var _match = _hash.match(new RegExp("!pg:"+i+":\\d+!") );
        if(_match &&  _match.length > 0){
            var _pg = parseInt(_match[0].split(':').pop().slice(0,-1));
            if(_pg > 0 && _pg < _target.children().length){
                _pager_control_input.data('current-page',_pg);
            }
        }*/
        if(!_pager_control_input.data('current-page')){
            _pager_control_input.data('last-page',1);
        } else {
            _pager_control_input.data('last-page',_pager_control_input.data('current-page'));
        }
        var _dependent_pagers = _target.data('dependent-pagers') || [];
        if(!_target.data('main-pager')){
            _target.data('main-pager',_pager_control);
        } else {
            _dependent_pagers.push(_pager_control);
            _target.data('dependent-pagers',_dependent_pagers);
        }
        if(_dependent_pagers.length > 0){
            _pager_control.jqPagination({
                'page_string': '{current_page} von {max_page}',
                'max_page': _target.data('main-pager').jqPagination('option','max_page'),
                paged: function(page) {
                    if(_pager_control_input.data('last-page') != page){
                        _target.data('main-pager').jqPagination('option','current_page',page);
                    }
                }
            });

        } else {
            var _last_page = _pager_control_input.data('last-page') || '1';
            _target.find('.pager-page:nth-of-type('+_last_page+')').siblings('.pager-page').hide();
            _pager_control.jqPagination({
                'page_string': '{current_page} von {max_page}',
                'current_page': _pager_control_input.data('current-page'),
                'max_page': _target.find('.pager-page').length,
                paged: function(page) {
                    //_pager_control.find('[data-action=first]')
                    _target.find('.pager-page').stop(true,true);
                    var _target_overflow = _target.get(0).style.overflow;
                    var _target_height = _target.get(0).style.height;
                    var _target_calc_height = _target.innerHeight();
                    var _active_page = _pager_control_input.data('last-page');
                    var _current = _target.find('.pager-page:nth-of-type('+_active_page+')');
                    var _current_margin_top = _current.get(0).style.marginTop;
                    var _current_calc_height = _current.innerHeight();
                    var _next = _target.find('.pager-page:nth-of-type('+page+')');
                    var _next_margin_top = _next.get(0).style.marginTop;
                    var _next_calc_height = _next.innerHeight();
                    if(_active_page-1 == page && !_next.is('tbody')){ // slide in from top
                        _target.css('overflow','hidden');
                        _target.css('position','relative');
                        _target.css('height',_target.innerHeight()+'px');
                        _next.css('margin-top','-'+_next.innerHeight()+'px').show().animate({'margin-top':'0px'},{
                            duration: 300,
                            easing: 'swing',
                            step: function( now, fx ) {
                                if(_target_calc_height < _next_calc_height + now){
                                    _target.css('height',(_next_calc_height + now)+'px');
                                }
                            },
                            always: function(promise,jumpedToEnd){
                                _current.hide();
                                _next.css('margin-top',_next_margin_top);
                                if(!jumpedToEnd){
                                    _target.css('overflow',_target_overflow);
                                    _target.css('height',_target_height);
                                }

                            }});
                    }
                    if(_active_page+1 == page && !_next.is('tbody')){ // slide in from bottom
                        _target.css('overflow','hidden');
                        _target.css('position','relative');
                        _target.css('height',_target.innerHeight()+'px');
                        _next.show();
                        _current.animate({'margin-top':'-'+_current.innerHeight()+'px'},{
                            duration: 300,
                            easing: 'swing',
                            step: function( now, fx ) {
                                if(_target.innerHeight() > _next_calc_height + (_current_calc_height + now) ){
                                    _target.css('height',(_next_calc_height + (_current_calc_height + now))+'px');
                                }
                            },
                            always: function(promise,jumpedToEnd){
                                _current.hide();
                                _current.css('margin-top',_current_margin_top);
                                if(!jumpedToEnd){
                                    _target.css('overflow',_target_overflow);
                                    _target.css('height',_target_height);
                                }
                            }});
                    }
                    if(_active_page+1 < page || _active_page-1 > page || _next.is('tbody')){
                        _next.show('fade');
                        _current.hide();
                    }
                    _pager_control_input.data('last-page',page);
                   /* if(_match &&  _match.length > 0){
                        location.hash = "#"+_hash.replace(new RegExp("!pg:"+i+":\\d+!"),"!pg:"+i+":"+page+"!" );
                    } else {
                        location.hash = "#"+_hash+"!pg:"+i+":"+page+"!";
                    }*/

                    $(_target.data('dependent-pagers')).each(function(){
                        $(this).jqPagination('option','current_page',page);
                    });
                }
            });
        }

    });
});

/********************************************************************************************\
 *
 * BOOTSTRAP TABS
 *
\********************************************************************************************/
vsb_init_page_load_chain.push(function(document){
    // EVENT when button clicked inside a tab content, opens the next tab
    $(document).on('click', '[data-toggle="tab-next"]', function(e) {
        var _tab_id = $(this).closest('.tab-pane').nextAll('.tab-pane:not(.disabled):first').attr('id');
        $('a[href="#'+_tab_id+'"]').tab('show');
        e.preventDefault();
    });

    // EVENT when button clicked inside a tab content, opens the previous tab
    $(document).on('click', '[data-toggle="tab-previous"]', function(e) {
        var _tab_id = $(this).closest('.tab-pane').prevAll(".tab-pane:not(.disabled):first").attr('id');
        $('a[href="#'+_tab_id+'"]').tab('show');
        e.preventDefault();
    });


    $(document).on('shown.bs.tab','a[data-toggle="tab"]', function() {
        var _pane = $($(this).attr('href'));
        _pane.find('div[data-role="vsb-jqplot"]').each(function(){
           if(_vsb_jqplot_registry[$(this).attr('id')]){
               _vsb_jqplot_registry[$(this).attr('id')].replot();
           }
        });
    });

    // EVENT may be added on a CHECKBOX element. disable/enable the target tab.
    // next/previous tab buttons are hidden/shown in case any not disabled tab is/isnt the first or last tab afterwards
    $(document).on('click', '[data-action="tab-toggle-disabled"]', function(e) {
        this.disabled=true;
        var _ctrl = $('a[href="#'+$(this).data('target')+'"]');
        var _pane = $('#'+$(this).data('target'));
        if( _ctrl.closest('li').hasClass('disabled') ){
            //show
            _ctrl.closest('li').removeClass('disabled');
            _pane.removeClass('disabled');
            vsb_enable_form_elements_for_node(_pane);
        } else {
            //hide
            _ctrl.closest('li').addClass('disabled');
            _pane.addClass('disabled');
            vsb_disable_form_elements_for_node(_pane);
        }
        $(_pane).closest('.tab-content').children('.tab-pane').each(function(){
            $(this).find('[data-toggle="tab-next"]').show();
            $(this).find('[data-toggle="tab-previous"]').show();
        });
        $(_pane).closest('.tab-content').children('.tab-pane:not(.disabled):last').each(function(){
            $(this).find('[data-toggle="tab-next"]').hide();
        });
        $(_pane).closest('.tab-content').children('.tab-pane:not(.disabled):first').each(function(){
            $(this).find('[data-toggle="tab-previous"]').hide();
        });
        this.disabled=false;
    });

});

vsb_init_dynamic_content_chain.push(function(content){

    // enable tabs that are referenced in html anchor
    var _hash = window.location.hash;
    _hash && $('ul.nav a[href="' + _hash + '"]').tab('show');

    // make the first tab with form errors active
    $(content).find('.tab-content').each(function(){
        var _error=  $(this).find('.has-error').first();
        var _id = $(_error).closest('.tab-pane').attr('id');
        $("a[href='#"+_id+"']").tab('show');
    });

    // synchronize the tab with the initial state of the checkbox
    $(content).find('[data-action="tab-toggle-disabled"]').each( function(e) {
        var _ctrl = $('a[href="#'+$(this).data('target')+'"]');
        var _pane = $('#'+$(this).data('target'));
        if($(this).is(':checked')){
            _ctrl.closest('li').removeClass('disabled');
            _pane.removeClass('disabled');
            vsb_enable_form_elements_for_node(_pane);
        } else {
            _ctrl.closest('li').addClass('disabled');
            _pane.addClass('disabled');
            vsb_disable_form_elements_for_node(_pane);
        }
    });

    // synchronize the next/prev buttons visibility with the initial state of tab-toggle-disabled checkboxes
    $(content).find('.tab-content').each( function(e) {
        $(this).children('.tab-pane:not(.disabled):last').each(function(){
            $(this).find('[data-toggle="tab-next"]').hide();
        });
        $(this).children('.tab-pane:not(.disabled):first').each(function(){
            $(this).find('[data-toggle="tab-previous"]').hide();
        });
    });

});

/********************************************************************************************\
 *
 * BOOTSTRAP ACCORDION/COLLAPSE
 *
\********************************************************************************************/
vsb_init_page_load_chain.push(function(document){
    // EVENT Bootstrap accordion only working for panels out of the box, initialize for arbitrary elements
    // elements must be children of .accordion class
    $(document).on('click',".accordion a[data-toggle='collapse']", function() {
        var current = $(this).attr("href");
        current = $(current);
        if (!$(this).closest('.accordion').hasClass('accordion-all-open')) {
            $(this).closest('.accordion').find('.collapse').each(function () {
                if (!$(this).is(current)) {
                    $(this).collapse('hide');
                }
            });
        }
    });

    // EVENT manage chevron marking open/close state in accordions
    $(document).on('show.bs.collapse','.collapse', function(e){
        var _ctrl = $('a[data-toggle="collapse"][href="#'+$(this).attr('id')+'"] > i.glyphicon-chevron-right');
        _ctrl.removeClass('glyphicon-chevron-right').addClass('glyphicon-chevron-down');
    });

    // EVENT manage chevron marking open/close state in accordions
    $(document).on('hide.bs.collapse','.collapse', function(e){
        var _ctrl = $('a[data-toggle="collapse"][href="#'+$(this).attr('id')+'"] > i.glyphicon-chevron-down');
        _ctrl.removeClass('glyphicon-chevron-down').addClass('glyphicon-chevron-right');
    });



});


vsb_init_dynamic_content_chain.push(function(content){
    // INIT synchronize chevron marking open/close state in accordions with initial open/close state
    // $(content).find('.accordion').each(function(){
    //     $(this).find('a[data-toggle="collapse"] > i.glyphicon').each(function(){
    //         $(this).removeClass('glyphicon-chevron-right').addClass('glyphicon-chevron-down');
    //     });
    //     $(this).find('a[data-toggle="collapse"].collapsed > i.glyphicon').each(function(){
    //         $(this).removeClass('glyphicon-chevron-down').addClass('glyphicon-chevron-right');
    //     });
    // });

    // added content
    if(content != document){
        var _el = $(content).find('.collapse:last');
        if(_el.length!=0){
            _el.collapse('show');
            _el.closest('.accordion').find('.collapse').each(function() {
                if (!$(this).is(_el)) {
                    $(this).collapse('hide');
                }
            });
        }
    }

    // any tabs containing errors must be visible
    $(content).find('.collapse[role="tabpanel"]').each(function(){
        if($(this).find('.has-error').size() > 0) {
            $(this).addClass('in');
        }
    });
});

/********************************************************************************************\
 *
 * TABLE ROW DYNAMIC ADD
 *
\********************************************************************************************/
vsb_init_page_load_chain.push(function(document){

    // EVENT react to click on "add table row" element
    $(document).on('click', '[data-action="add-table-row"]', function(e) {
        // this is for having the rows numbered
        var _start_child_index = $(this).data('start-child-index');
        if(! _start_child_index >= 0){
            _start_child_index = new Date().getTime();
        }
        if ( typeof arguments.callee.counter == 'undefined' ) { arguments.callee.counter = _start_child_index; }
        // we get the template from a script tag in tbody
        var _template = $(this).closest('table').children('tbody').children('script[type="text/template"]');
        var _decoded = Base64.decode(_template.text().trim());
        // the opportunity to have the string "{id}" in template replaced with a unique token
        var _token = Math.random().toString(36).substr(2, 16);
        _decoded = _decoded.replace(/\{id\}/g, _token);
        // the opportunity to have the string "_child_index[n]" in template replaced with an incrementing counter
        var _current_idx = ++arguments.callee.counter
        _decoded = _decoded.replace(/_child_index\{(\d+)\}/g, (_current_idx).toString()+"$1" );
        // the opportunity to have the string "_child_index_" in template replaced with an incrementing counter (PROPABLY NOT WORK WITH MULTIPLE TABLE ON PAGE)
        _decoded = _decoded.replace(/_child_index_/g, _current_idx);
        _decoded = $(_decoded)
        // we run the dynamic content intializer chain for the new content
        // we must replace all the id's, otherwise there will be duplicate ids on multiple add
        _decoded.find('[id]').each(function(){
            if($(this).attr('id').indexOf(_token) == -1 ){
                $(this).attr('id', $(this).attr('id') + "_" +_token);
            }
        });
        _template.before(_decoded);
        vsb_apply_chain(vsb_init_dynamic_content_chain,_decoded);
    });

    // EVENT react to click on "remove table row" element
    $(document).on('click', '[data-action="remove-table-row"]', function(e) {
        var position= $(window).scrollTop();
        var _tr = $(this).closest('tr');
        _tr.remove();
        $(window).scrollTop(position);
    });
});

vsb_init_dynamic_content_chain.push(function(content){
 // noop
});


/********************************************************************************************\
 *
 * LIST ITEM DYNAMIC ADD
 *
\********************************************************************************************/
vsb_init_page_load_chain.push(function(document){

    // EVENT react to click on "add list item" element
    $(document).on('click', '[data-action="add-list-item"]', function(e) {
        // this is for having the rows numbered
        var _child_index_token = $(this).data('child-index-token');
        if(! _child_index_token){
            _child_index_token = '_child_index_'
        }
        var _start_child_index = $(this).data('start-child-index');
        if(! _start_child_index >= 0){
            _start_child_index = new Date().getTime();
        }
        if ( typeof arguments.callee.counter == 'undefined' ) { arguments.callee.counter = _start_child_index; }
        
        var _template = $(this).closest('ul,ol').children('script[type="text/template"]');
        var _text = Base64.decode(_template.text().trim());
        var _fio = false;
        if(_text.indexOf('<!--') == 0){ // problems with nested templates, html comment workaround, probably also necessary for table row stuff
            _text = _text.slice(4);
            _fio=true;
        }
        if(_fio && _text.lastIndexOf('-->') == _text.length - 3){
            _text = _text.slice(0,-3);
        }
        var _token = Math.random().toString(36).substr(2, 16);
        var _new = _text.replace(/\{id\}/g, _token);
        // we must replace all the id's, otherwise there will be duplicate ids on multiple add

        // the opportunity to have the string "_child_index[n]" in template replaced with an incrementing counter
        var _current_idx = ++arguments.callee.counter
        _new = _new.replace(/_child_index\{(\d+)\}/g, (_current_idx).toString()+"$1" );
        // the opportunity to have the string "_child_index_" in template replaced with an incrementing counter (PROPABLY NOT WORK WITH MULTIPLE TABLE ON PAGE)

        _new = _new.replace(  new RegExp(_child_index_token,'g'), _current_idx);
        _new = $(_new)
        
        _new.find('[id]').each(function(){
            if($(this).attr('id').indexOf(_token) == -1 ){
                $(this).attr('id', $(this).attr('id') + "_" +_token);
            }
        });
        _template.before(_new);
        vsb_apply_chain(vsb_init_dynamic_content_chain,_new);
    });

    // EVENT react to click on "remove list item" element
    $(document).on('click', '[data-action="remove-list-item"]', function(e) {
        var position= $(window).scrollTop();
        var _tr = $(this).closest('li');
        _tr.remove();
        $(window).scrollTop(position);
    });
});

vsb_init_dynamic_content_chain.push(function(content){
    // noop
});

/********************************************************************************************\
 *
 * SHOW FORM FIELD HELP TEXT WHEN FIELD HAS FOCUS / FOCUS + ENTERED VALUE MATCHES PATTERN
 *
 * <div class="form-group has-error">
 *   <div class="col-sm-9">
 *
 *   <span  class="help-block small"><%= message %></span>
 * <% end %>
 * </div>
 * </div>
 \********************************************************************************************/

/********************************************************************************************\
 *
 * TOGGLE VISIBILITY OF CONTENT WITH A SINGLE CHECKBOX/LINK/BUTTON
 *
 * <a href="#" data-action="toggle-disabled-state" data-target="#target">show/hide content</a>
 * <div id="target">
 *    toggle content
 * </div>
\********************************************************************************************/
vsb_init_page_load_chain.push(function(document){

    // EVENT when clicked, or checked/unchecked, toggle content accordingly
    $(document).on('click', '[data-action="toggle-disabled-state"]', function(e) {
        var _el = $($(this).data('target')); // when target is a form input, DISABLE/ENABLE instead
        var position= $(window).scrollTop();
        if($(this).is(':checkbox')){
            var _enable=$(this).is(':checked') ;
            if($(this).data('inverse-toggle')){
                _enable= !_enable;
            }
            if(_enable){
                if(_el.is(':input')){
                    _el.prop('disabled', false);
                } else {
                    _el.show();
                    vsb_enable_form_elements_for_node(_el);
                }
            } else {
                if(_el.is(':input')){
                    _el.prop('disabled', true);
                } else {
                    _el.hide();
                    vsb_disable_form_elements_for_node(_el);
                }
            }
        } else {
            if(_el.is(':input')){
                _el.prop('disabled', function(i, v) { return !v; });
            } else {
                if(_el.is(':visible')){
                    vsb_disable_form_elements_for_node(_el);
                    _el.hide();
                } else {
                    vsb_enable_form_elements_for_node(_el);
                    _el.show();
                }
            }
        }
        $(window).scrollTop(position);
    });
});

vsb_init_dynamic_content_chain.push(function(content){

    // INIT synchronize with initial checkbox state
    // document is used on purpose, as there may be targets loaded of already existing elements with data-action="toggle-disabled-state"
    $(document).find('[data-action="toggle-disabled-state"]').each( function() {
        var _el = $($(this).data('target'));
        if($(content).find(_el).length == 0){return}
        if($(this).is(':checkbox')){
            var _enable=$(this).is(':checked') ;
            if($(this).data('inverse-toggle')){
                _enable= !_enable;
            }
            if( _enable  ){
                if(_el.is(':input')){
                    _el.prop('disabled', false);
                } else {
                    _el.show();
                    vsb_enable_form_elements_for_node(_el);
                }
            } else {
                if(_el.is(':input')){
                    _el.prop('disabled', true);
                } else {
                    _el.hide();
                    vsb_disable_form_elements_for_node(_el);
                }
            }
        } else {
            // ensure form inputs are disabled inside
            if(_el.is(':visible')){
                vsb_enable_form_elements_for_node(_el);
            } else {
                vsb_disable_form_elements_for_node(_el);
            }
        }
    });
});

/********************************************************************************************\
 * 
 * TOGGLE VISIBILITY OF CONTENT WITH SEVERAL LINKED RADIOS/BUTTONS/LINKS
 * OR ONE SELECTBOX
 *
 * <a href="#" data-action="toggle-choices-state" data-target="#target1" data-target-all=".target">show target1</a>
 * <a href="#" data-action="toggle-choices-state" data-target="#target2" data-target-all=".target">show target2</a>
 * <div id="target1" class="target">
 *  show content 1 and hide other
 * </div>
 * <div id="target2" class="target">
 *  show content 2 and hide other
 * </div>
 * 
 * <select data-action="toggle-choices-state" data-target-all=".target">
 *   <option data-target="#target1">show target1</option>
 *   <option data-target="#target2">show target2</option>
 * </select>
 * <div id="target1" class="target">
 *  show content 1 and hide other
 * </div>
 * <div id="target2" class="target">
 *  show content 2 and hide other
 * </div>
 \********************************************************************************************/
vsb_init_page_load_chain.push(function(document){

    // EVENT when clicked, or checked/unchecked/selected, toggle content accordingly
    $(document).on('click, change', '[data-action="toggle-choices-state"]', function(e) {
        var _el = $($(this).data('target-all'));
        if($(this).is('select')){
            var position= $(window).scrollTop();
            vsb_disable_form_elements_for_node(_el);
            _el.hide();
            var _t = null;
            $(this).find('option[data-target]:checked, option[data-target]:selected').each(function(){
                _t = $($(this).data('target'));
                vsb_enable_form_elements_for_node(_t);
                _t.show(  );
            });

            $(window).scrollTop(position);
        } else {
            
            var position= $(window).scrollTop();
            var _t = $($(this).data('target'));
            vsb_disable_form_elements_for_node(_el);
            _el.hide( );
            vsb_enable_form_elements_for_node(_t);
            _t.show(  );
            $(window).scrollTop(position);
        }
    });

    // $(document).find('[data-action="toggle-choices-state"]').each( function() {
    //     // CODE DUPLICATION, SEE HANDLER ABOVE
    //     var _el = $($(this).data('target-all'));
    //     if($(this).is('select')){
    //         vsb_disable_form_elements_for_node(_el);
    //         _el.hide();
    //         var _t = null;
    //         $(this).find('option[data-target]:checked, option[data-target]:selected').each(function(){
    //             _t = $($(this).data('target'));
    //             vsb_enable_form_elements_for_node(_t);
    //             _t.show(  );
    //         });
    //     } else {
    //         var _t = $($(this).data('target'));
    //         vsb_disable_form_elements_for_node(_el);
    //         _el.hide( );
    //         vsb_enable_form_elements_for_node(_t);
    //         _t.show( );
    //     }
    // });

});

vsb_init_dynamic_content_chain.push(function(content){

    // document is used on purpose, as there may be targets loaded of already existing elements with data-action="toggle-choices-state"
    $(document).find('[data-action="toggle-choices-state"]').each( function(e) {
        if($(document).find('[data-action="toggle-choices-state"][name="'+$(this).attr('name')+'"]:checked').length==0){
           $(document).find('[data-action="toggle-choices-state"][name="'+$(this).attr('name')+'"]:first').prop('checked', true);
        }
    });

    // INIT synchronize with initial select/checkbox state
    // document is used on purpose, as there may be targets loaded of already existing elements with data-action="toggle-choices-state"
    $(document).find('[data-action="toggle-choices-state"]').each( function(e) {
        var _el = $($(this).data('target-all'));
        if($(content).find(_el).length == 0){return}
        if($(this).is('select')){
            vsb_disable_form_elements_for_node(_el);
            _el.hide();
            var _t = null;
            $(this).find('option[data-target]:checked, option[data-target]:selected').each(function(){
                _t = $($(this).data('target'));
                vsb_enable_form_elements_for_node(_t);
                _t.show();
            });
        }
        if($(this).is(':radio')){
            if($(this).prop('checked')){
        
                var _t = $($(this).data('target'));
                vsb_disable_form_elements_for_node(_el);
                _el.hide( );
                vsb_enable_form_elements_for_node(_t);
                _t.show();
            }
        }
    });
});


/****************************************************************************************
 *
 * DEPENDENT FORM FIELDS
 *
 * class="chained-form-element" (mandatory)
 *      - set this class to activate the functionality
 *
 * data-load-from="/some/action" (optional)
 *      - This is the action where the ajax request for following form elements goes.
 *      - Idefault on current action
 *
 * data-load-into="example_id" (mandatory)
 *      - There must be a method "example_id()" on the controller responsible for the action
 *      - This method is called on_before_action by application controller
 *      - after this method returns, a view partial with name "_example_id.html.erb" is rendered without layout
 *      - the controller then exits.
 *      - the dom element with id="example_id" is then updated with the response
 *      - if you want to show the initial content, let the controller render an empty response
 *
 * data-include=".blablubb" (optional)
 *      - Parameters are sent according to the name attributes of form elements.
 *      - data-include lets one specify a selector to include additional form elements in the ajax request.
 *
 *
 \********************************************************************************************/
vsb_init_page_load_chain.push(function(document){
    var _ajax_call = function(element){
        var _load_into = element.data('load-into');
        var _load_into_obj = $("#"+_load_into)
        var _arguments = { chained_form_element: _load_into  }; // to indicate this is request for chained form elements, also contains partial to load
        _arguments[element.attr('name')] = element.val(); // this will be sth like foo[bar_id]=1234
        $($(element).attr('data-include')).each(function(){
            _arguments[$(this).attr('name')] = $(this).val(); // this will be some other dependent elements like foo[baz_id]=1234
        });
        // this is for restoring the intitial content, when the ajax request returns 204 nocontent as result
        if(typeof $.data(document.body,_load_into+"_obj") === 'undefined'){
            $.data(document.body,_load_into+"_obj",_load_into_obj.clone());
        }
        $.ajax({
            url:  element.data('load-from'), // using same url when not set
            data: _arguments,
            success: function(data, textStatus, jqXHR){
                _load_into_obj.empty().html(data);
                vsb_apply_chain(vsb_init_dynamic_content_chain,_load_into_obj);
            },
            error: function(jqXHR, textStatus, errorThrown ){
                _load_into_obj.replaceWith( $.data(document.body,_load_into+"_obj").clone() );
                vsb_apply_chain(vsb_init_dynamic_content_chain,_load_into_obj);
            },
            dataType: 'html'
        });
    };
    $(document).on("change", 'select.chained-form-element', function (e) {
        _ajax_call($(this))
    });
    $(document).on("dp.change", 'input.datepicker.chained-form-element', function (e) {
        _ajax_call($(this))
    });
    $(document).on("change", 'input.datepicker', function (e) {
        _ajax_call($(this))
    });
});

vsb_init_dynamic_content_chain.push(function(content){
});

/********************************************************************************************\
 *
 * Address check
 * 
 \********************************************************************************************/
vsb_init_page_load_chain.push(function(document){

    var _address_validations =$('.address-validation');
    $(document).on('change', _address_validations.find(':input'), function(event) {
        var _closest_address_validation = $(event.target).closest('.address-validation');
        var _query = {};
        var _fields =  _closest_address_validation.find('[data-address-field]');
        _fields.each(function () {
            _query[$(this).data('address-field')] = $(this).val();
        });
        // check that street and number + city or plz are filled
        if( _query['street'] != ''  && (_query['zip'] != '' || _query['city'] != '') ){
                $.ajax({
                    url: '/addresses/search.json',
                    data: _query,
                    success: function (data, textStatus, jqXHR) {
                        if (data['valid']) {
                            var _formatted_address = _closest_address_validation.find('.btn-address-validation .formatted-address')
                            _formatted_address.html(data['formatted_address']);
                            _formatted_address.data('search-string',data['search_string']);
                            _closest_address_validation.find('.btn-address-validation').fadeIn();
                        } else {
                            _closest_address_validation.find('.btn-address-validation').fadeOut();
                        }
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        _closest_address_validation.find('.btn-address-validation').fadeOut();
                    },
                    dataType: 'json'
                });
        }
    });
    $(document).on('click', '.btn-address-validation', function(event) {
        var btn = $(this);
        var wrp = $(btn).closest('.address-validation');
        var hsh = {};
        var fld =  wrp.find('[data-address-field]');
        var _formatted_address = wrp.find('.btn-address-validation .formatted-address');
        hsh['q']=_formatted_address.data('search-string');
        if(hsh['q'] != '') {
            $.ajax({
                url: '/addresses/search.json', // using same url when not set
                data: hsh,
                success: function (data, textStatus, jqXHR) {
                    if (data['valid']) {
                        fld.each(function () {
                            if (data['address'][$(this).data('address-field')]) {
                                $(this).val(data['address'][$(this).data('address-field')]);
                            }

                        });
                    }
                    wrp.find('.btn-address-validation').fadeOut();
                },
                dataType: 'json'
            });
        } else {
            wrp.find('.btn-address-validation').fadeOut();
        }
        event.preventDefault();
    });
});

vsb_init_dynamic_content_chain.push(function(content){

});

/********************************************************************************************\
 *
 * WRAP MARKUP INTO IFRAME
\********************************************************************************************/
vsb_init_page_load_chain.push(function(document){
    // adjust height of iframes with text content
    $(document).on('load page:load resize orientationChange shown.bs.tab', function(event) {
        $('iframe[data-action="load-content"]').each(function(){
            var _d = $(this)[0].contentWindow.document;
            var _c = $(this).next('script[type="text/template"]')[0].childNodes[0].nodeValue;
            _c = _c.replace(/^\s+|\s+$/gm, '');
            var _f = false;
            if (_c.indexOf('<!--') == 0) {
                _c = _c.slice(4);
                _f = true;
            }
            if (_f && _c.lastIndexOf('-->') == _c.length - 3) {
                _c = _c.slice(0, -3);
            }
            _d.open(); _d.write(Base64.decode(_c)); _d.close();
            this.style.height=this.contentWindow.document.body.scrollHeight*1.15+'px';
        });
    });

    // is this needed? this is used by table-slide-in and panel-slide-in
    $(document).on('click', 'button[data-toggle]', function(e) {
        $($(this).data('toggle')).toggleClass('active');
    });

});

vsb_init_dynamic_content_chain.push(function(content){
    $(content).find('iframe[data-action="load-content"]').each(function(el){
        var _d = $(this)[0].contentWindow.document;
        var _c = $(this).next('script[type="text/template"]')[0].childNodes[0].nodeValue;
        _c = _c.replace(/^\s+|\s+$/gm, '');
        var _f = false;
        if (_c.indexOf('<!--') == 0) {
            _c = _c.slice(4);
            _f = true;
        }
        if (_f && _c.lastIndexOf('-->') == _c.length - 3) {
            _c = _c.slice(0, -3);
        }
        _d.open(); _d.write(Base64.decode(_c)); _d.close();
        this.style.height=this.contentWindow.document.body.scrollHeight*1.15+'px';
    });
});
