module Grants
  class AdvancementPlan
      def self.grants
        {
          create: {
              name: 'hinzufügen',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      detailed_description: "keine Einschränkungen" ,
                      user_types: [::Manager,::Teacher],
                      default_for: [::Manager,::Teacher],
                      manager: -> ability do
                        ability.can :create, ::AdvancementPlan
                      end,
                      teacher: -> ability do
                        ability.can :create, ::AdvancementPlan
                      end
                  },

              }
          },
          read: {
              name: 'anzeigen',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      detailed_description: "keine Einschränkungen" ,
                      user_types: [::Manager,::Teacher],
                      default_for: [::Manager,::Teacher],
                      manager: -> ability do
                        ability.can :read, ::AdvancementPlan
                      end,
                      teacher: -> ability do
                        ability.can :read, ::AdvancementPlan
                      end
                  },
              }
          },
          update: {
              name: 'bearbeiten',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      detailed_description: "keine Einschränkungen" ,
                      user_types: [::Manager,::Teacher],
                      default_for: [::Manager,::Teacher],
                      manager: -> ability do
                        ability.can :update, ::AdvancementPlan
                      end,
                      teacher: -> ability do
                        ability.can :update, ::AdvancementPlan
                      end
                  },
              }
          },
          destroy: {
              name: 'löschen',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      detailed_description: "keine Einschränkungen" ,
                      user_types: [::Manager,::Teacher],
                      default_for: [::Manager,::Teacher],
                      manager: -> ability do
                        ability.can :destroy, ::AdvancementPlan
                      end,
                      teacher: -> ability do
                        ability.can :destroy, ::AdvancementPlan
                      end
                  },
              }
          }
        }
      end
  end
end