module Grants
  class ChecklistTpl
    def self.grants
      {
          create: {
              name: 'Anlegen',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      detailed_description: '
                        Vorlagen für Checklisten anlegen
                      ',
                      user_types: [::Manager],
                      default_for: [::Manager],
                      manager: -> ability do
                        ability.can :create, ::ChecklistTpl
                      end
                  }
              }
          },
          read: {
              name: 'Anzeigen',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      detailed_description: '
                         Vorlagen für Checklisten anzeigen
                      ',
                      user_types: [::Manager],
                      default_for: [::Manager],
                      manager: -> ability do
                        ability.can :read, ::ChecklistTpl
                      end
                  }
              }
          },
          update: {
              name: 'Bearbeiten',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      detailed_description: '
                       Vorlagen für Checklisten bearbeiten
                      ',
                      user_types: [::Manager],
                      default_for: [::Manager],
                      manager: -> ability do
                        ability.can :update, ::ChecklistTpl
                      end
                  }
              }
          },
          destroy: {
              name: 'Löschen',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      detailed_description: '
                         Vorlagen für Checklisten löschen
                      ',
                      user_types: [::Manager],
                      default_for: [::Manager],
                      manager: -> ability do
                        ability.can :destroy, ::ChecklistTpl
                      end
                  }
              }
          }

      }
      end
  end
end