module Grants
  class SystemConfiguration
      def self.subject_title; 'Systemeinstellungen'; end;
      def self.grants
        {
          update: {
              name: 'Bearbeiten',
              scopes: {
                  system_wide: {
                      name: 'Systemweit',
                      user_types: [::Manager],
                      default_for: [],
                      manager: -> ability do
                        ability.can :update, :system_configuration
                        ability.can :read, :system_configuration
                      end

                  },
              }
          },
        }
      end
  end
end