class PortfolioItemEvaluationDbrsController < ApplicationController

  before_filter :set_timezone

  def set_timezone
    Time.zone = 'GMT'
  end


  # this is rather to update the results, the other dbr attributes are nested in portfolio item form
  def update
    @dbr = ::Portfolio::ItemEvaluationDbr.where(id: params[:id]).take!
    @date =   Time.at(params[:date].to_i).to_datetime.to_date
    authorize!(:update, @dbr.portfolio_item)
    #abort dbr_params.inspect
    @dbr.assign_attributes(dbr_params)
    respond_to do |format|
      @dbr.save
      format.js { render :update }
    end
  end

  def dbr_params
    params.require(:portfolio_item_evaluation_dbr).permit(
        results_attributes: [
            :id, :portfolio_item_evaluation_dbr_characteristic_id, :line_idx, :time, :value, :_destroy
        ]
    )
  end

end
