class RegistrationsController < Devise::RegistrationsController

  def build_resource(hash=nil)
    super
    if hash.empty?
      self.resource.identifiable = Manager.new
    else
      self.resource.identifiable = Manager.new(identifiable_params)
    end
  end


  private

  def sign_up_params
    params.require(resource_name).permit(:username,:email, :password, :password_confirmation, :remember_me)
  end

  def account_update_params
    params.require(resource_name).permit(:username,:email, :password, :password_confirmation, :current_password)
  end

  def identifiable_params
    params.require(:identifiable).permit(:first_name,:last_name,:gender,:email,:phone,:mobile,:fax,:website)
  end


end
