class ChecklistTplsGrid < BaseGrid

  scope do
    ChecklistTpl.all
  end

  filter(:is_active, :xboolean, header: "Freigeschaltete", default: nil)  do |value|
    self.where(["checklist_tpls.is_active = ?",  value])
  end
  filter(:name, :string, header: 'Name') do |value,scope|
    scope.where(["checklist_tpls.name ILIKE ?", "%#{value}%" ])
  end

  column(:name, header: "Name",  order: :name, html: true) do |checklist_tpl|
    checklist_tpl.name
  end

  column(:checklist_type, header: "Typ",  order: :checklist_type, html: true) do |checklist_tpl|
    checklist_tpl.checklist_type
  end

  column(:is_active, header: "Freigeschaltet", html: true) do |checklist_tpl|
    if checklist_tpl.is_active
      content_tag(:i, nil, class: 'glyphicon glyphicon-check text-success')
    else
      content_tag(:i, nil, class: 'glyphicon glyphicon-unchecked text-danger')
    end
  end

  column(:actions,  header: '', :html => true) do |i|
    _wrp = 0
    update_button = ""
    delete_button = ""
    if can?(:update,i)
      _wrp += 1
      update_button = "<a href='#{edit_checklist_tpl_path(i)}' role='button' class='btn btn-success'>
        <i class='glyphicon glyphicon-pencil'></i>
      </a>"
    end
    if can?(:destroy,i)
      _wrp += 1
      delete_button = link_to  checklist_tpl_path(i), data: {:confirm => 'Sicher?'},
                               role: 'button', class: 'btn btn-danger', :method => :delete do
        content_tag(:i, nil, class: 'glyphicon glyphicon-remove')
      end
    end
    "<div class='btn-group btn-group-nowrap-#{_wrp} btn-group-xs  pull-right' >
    #{update_button}
    #{delete_button}
      </div>".html_safe

  end


end