class TeacherCategoriesGrid < BaseGrid

  scope do
    TeacherCategory.all
  end

  filter(:name, :string, header: "Name") do |value|
    self.where(["teacher_categories.name LIKE ?",  "%#{value}%"])
  end
  filter(:is_support_teacher, :xboolean, header: "Unterstützungslehrer")
  filter(:is_special_ed, :xboolean, header: "Sonderpädagoge")

  column(:name, header: "Name")
  column(:is_support_teacher, header: "Unterstützungslehrer") do |i|
    i.is_support_teacher? ? 'ja' : 'nein'
  end
  column(:is_special_ed, header: "Sonderpädagoge") do |i|
    i.is_special_ed? ? 'ja' : 'nein'
  end
  column(:actions,  header: '', style: 'width:100px', :html => true) do |i|
      "<div class='btn-group btn-group-nowrap btn-group-xs  pull-right' >
          <a href='#{edit_teacher_category_path(i)}' role='button' class='btn btn-success btn-sm'>
            <i class='glyphicon glyphicon-pencil'></i>
          </a>
            #{ link_to  teacher_category_path(i), data: {:confirm => 'Sicher?'},
             role: 'button', class: 'btn btn-danger btn-sm', :method => :delete do
             content_tag(:i, nil, class: 'glyphicon glyphicon-remove')
            end if i.is_destructable?  }
      </div>".html_safe
  end


end