class ClientDuplicateDetection < ActiveRecord::Base
  belongs_to :client_duplicate_detection_request
  belongs_to :client
  enum result_code: [:return_initial, :return_performed, :return_retry, :return_failed]

  validates :client_duplicate_detection_request_id, presence: true
  validates :bday, presence: true
  validates :duplicate_type, presence: true
  validates :first_name, presence: true
  validates :last_name, presence: true
  validates :gender, presence: true
  #t.string :institution_name, null: true
  #t.string :client_group_name, null: true

  after_create do
    ReturnClientDuplicateDetectionJob.perform_later(self)
    true
  end

end
