class ClientDuplicateResponse < ActiveRecord::Base
  belongs_to :client_duplicate_request, counter_cache: true

  validates :client_duplicate_request_id, presence: true
  validates :vsb_id, presence: true # the vsb that holds the (possible) duplicate
  validates :first_name, presence: true
  validates :last_name, presence: true
  validates :bday, presence: true
  validates :gender, inclusion: %w(m f)
  #t.string :institution_name, null: true
  #t.string :client_group_name, null: true
  #t.integer :client_id, null: true #  this is the client_id on the vsb that holds the duplicate

  scope :local_responses, -> {where(vsb_id: SystemSetting.get_instance.vsb_id )}
  scope :remote_responses, -> {where.not(vsb_id: SystemSetting.get_instance.vsb_id )}

  # after_create do
  #   if client_duplicate_request.announced_client_duplicate_responses_count.present? && client_duplicate_request.announced_client_duplicate_responses_count <= client_duplicate_request.client_duplicate_responses_count
  #     FinishClientDuplicateRequestJob.perform_now(client_duplicate_request)
  #   end
  #   true
  # end

  #after_destroy do # when all responses have been discarded, the client is created
  #   if client_duplicate_request.has_any_duplicates?
  #     #FinishClientDuplicateRequestJob.perform_now(client_duplicate_request)
  #   end
  #   true
  #end


  def is_local_response?
    vsb_id == SystemSetting.get_instance.vsb_id
  end
end
