class Document < ActiveRecord::Base

  ENUM_CATEGORY_OTHER_DOCUMENT = 0
  ENUM_CATEGORY_CONFIDENTIALITY_DOCUMENT = 1

  include Publishable

  #--- CW File Uploader
  mount_uploader :file, DocumentUploader

  #--- Associations
  belongs_to :attachable, polymorphic: true

  #--- Attributes
  enum category: { "sonstiges": ENUM_CATEGORY_OTHER_DOCUMENT, "Schweigepflichtentbindung": ENUM_CATEGORY_CONFIDENTIALITY_DOCUMENT }
  # TODO: wenn es mehr Arten von Anhängen gibt, würde es Sinn machen, sub classes zu verwenden

  #--- Callback definitions
  before_create :set_defaults_for_new

  #--- General Validations
  validates :file, presence: true

  #--- private methods
  private

    def set_defaults_for_new
      self.category ||= 0
    end

end
