module Portfolio
  module Conditions
    class ChecklistMatcher < ItemMatcher

        attr_accessor :type

        def initialize
          @type = nil
        end

        def match?(portfolio_item)
          unless portfolio_item.checklists.any?
            return false
          end
          portfolio_item.checklists.map{|cl| cl.checklist_type}.include?(@type)
        end

        def description
          "Der Eintrag sollte eine Checkliste vom Typ #{@type} umfassen"
        end
    end
  end
end
