module Portfolio
  class DiagnosticInformalResultGuardian < ::ActiveRecord::Base
    self.table_name = 'portfolio_item_diagnostic_informal_result_guardians'
    self.inheritance_column = nil

    belongs_to :diagnostic_informal_result,
             foreign_key: :portfolio_item_diagnostic_informal_result_id,
             class_name: '::Portfolio::DiagnosticInformalResult',
             inverse_of: :portfolio_diagnostic_informal_result_guardians

    belongs_to :guardian,
               foreign_key: :guardian_id,
               inverse_of: :portfolio_item_diagnostic_informal_result_guardians,
               class_name: '::Guardian'

    validates_uniqueness_of :portfolio_item_diagnostic_informal_result_id, :scope => :guardian_id
    validates :diagnostic_informal_result, :guardian, presence: true

  end
end

