module Portfolio
  # this is formal result can be attached to an informal result
  class ItemDiagnosticResult < ::ActiveRecord::Base
    self.table_name = 'portfolio_item_diagnostic_results'
    self.inheritance_column = nil

    belongs_to :characteristic, class_name: '::Characteristic',
               foreign_key: :characteristic_id,
               inverse_of: nil

    belongs_to :norm_scale, class_name: '::NormScale',
               foreign_key: :norm_scale_id,
               inverse_of: nil

    belongs_to :portfolio_diagnostic_informal_result,
               :foreign_key => :portfolio_item_diagnostic_informal_result_id,
               :class_name => 'Portfolio::DiagnosticInformalResult'

    validates :characteristic,:portfolio_diagnostic_informal_result, presence: true


    def norm_scale_name
      norm_scale.nil? ? 'Rohwerte' : norm_scale.name
    end

  end
end


