module Portfolio
  class ItemEvaluationDbrCharacteristic < ::ActiveRecord::Base
    self.table_name = 'portfolio_item_evaluation_dbr_characteristics'
    self.inheritance_column = nil
    # t.string :name
    # t.boolean :increase_is_positive


    belongs_to  :dbr,
                class_name: '::Portfolio::ItemEvaluationDbr',
                foreign_key: :portfolio_item_evaluation_dbr_id,
                inverse_of:  :characteristics

    has_many  :results,
              class_name: '::Portfolio::ItemEvaluationDbrResult',
              foreign_key: :portfolio_item_evaluation_dbr_characteristic_id,
              inverse_of:  :characteristic,
              dependent: :destroy

    validates :name, presence: true
    validates :name , length: { maximum: 140}
    validates :increase_is_positive , inclusion:  { in: [true,false] }

    after_create do
      dbr.lines.each_index  do |j|
        unless results.where(dbr: dbr, line_idx: j).any?
          dbr.number_of_data_points.times do
            results.create(dbr: dbr, line_idx: j)
          end
        end
      end
    end

  end
end


