module Portfolio
  class ItemInvolvedSupporter < ::ActiveRecord::Base
    self.table_name = 'portfolio_item_involved_supporters'
    self.inheritance_column = nil

    belongs_to :portfolio_item ,
               foreign_key: :portfolio_item_id,
               class_name: '::Portfolio::Item',
               inverse_of: :portfolio_item_involved_supporters
    delegate :portfolio_subject, to: :portfolio_item

    belongs_to :supporter,
               foreign_key: :supporter_id,
               class_name: '::Supporter',
               inverse_of: nil


    validates_uniqueness_of :portfolio_item_id, :scope => :supporter_id
    validates :portfolio_item, presence: true

  end
end

