module Questionnaires
  class SdqGuardian < SdqGuardianTeacher

    def accepts_guardian?
      true
    end

    def  self.questionnaire_name
      "SDQ (Goodman, 1997) für Eltern"
    end

    # @return Array[Questionnaire::Analysis]
    def analyses
      analyses=[]
      # Gesamtproblemwert
      all_questions_regarding_problems = questionnaire_results.select{|r| [1,2,3,4].include?(r.group_id) }
      filled_questions_regarding_problems = all_questions_regarding_problems.select{|r| r.result.present?}
      if filled_questions_regarding_problems.size == all_questions_regarding_problems.size # >= 12
        scaleing = (all_questions_regarding_problems.size.to_f / filled_questions_regarding_problems.size.to_f)
        value = filled_questions_regarding_problems.map(&:result).reduce(&:+) * scaleing
        analyses <<   Questionnaire::TernaryProblemAnalysis.new(1,1,"Gesamtproblemwert",value, left_maximum: 14, right_minimum: 17)
      end

      # Einzelne Bereiche
      all_questions_group_1 = questionnaire_results.select{|r| r.group_id == 1 }
      filled_questions_group_1 = all_questions_group_1.select{|r| r.result.present?}
      if filled_questions_group_1.size == all_questions_group_1.size # >= 4
        scaleing = (all_questions_group_1.size.to_f / filled_questions_group_1.size.to_f)
        value = filled_questions_group_1.map(&:result).reduce(&:+) * scaleing
        analyses <<   Questionnaire::TernaryProblemAnalysis.new(2,2,"Emotionale Probleme",value, left_maximum: 4, right_minimum: 5)
      end
      all_questions_group_2 = questionnaire_results.select{|r| r.group_id == 2 }
      filled_questions_group_2 = all_questions_group_2.select{|r| r.result.present?}
      if filled_questions_group_2.size == all_questions_group_2.size # >= 4
        scaleing = (all_questions_group_2.size.to_f / filled_questions_group_2.size.to_f)
        value = filled_questions_group_2.map(&:result).reduce(&:+) * scaleing
        analyses <<   Questionnaire::TernaryProblemAnalysis.new(3,3,"Verhaltensprobleme",value, left_maximum: 3, right_minimum: 4)
      end
      all_questions_group_3 = questionnaire_results.select{|r| r.group_id == 3 }
      filled_questions_group_3 = all_questions_group_3.select{|r| r.result.present?}
      if filled_questions_group_3.size == all_questions_group_3.size # >= 4
        scaleing = (all_questions_group_3.size.to_f / filled_questions_group_3.size.to_f)
        value = filled_questions_group_3.map(&:result).reduce(&:+) * scaleing
        analyses <<   Questionnaire::TernaryProblemAnalysis.new(4,4,"Hyperaktivität",value, left_maximum: 6, right_minimum: 7)
      end
      all_questions_group_4 = questionnaire_results.select{|r| r.group_id == 4 }
      filled_questions_group_4 = all_questions_group_4.select{|r| r.result.present?}
      if filled_questions_group_4.size == all_questions_group_4.size # >= 4
        scaleing = (all_questions_group_4.size.to_f / filled_questions_group_4.size.to_f)
        value = filled_questions_group_4.map(&:result).reduce(&:+) * scaleing
        analyses <<   Questionnaire::TernaryProblemAnalysis.new(5,5,"Verhaltensprobleme mit Gleichaltrigen",value, left_maximum: 3, right_minimum: 4)
      end
      all_questions_group_5 = questionnaire_results.select{|r| r.group_id == 5 }
      filled_questions_group_5 = all_questions_group_5.select{|r| r.result.present?}
      if filled_questions_group_5.size == all_questions_group_5.size # >= 4
        scaleing = (all_questions_group_5.size.to_f / filled_questions_group_5.size.to_f)
        value = filled_questions_group_5.map(&:result).reduce(&:+) * scaleing
        analyses <<   Questionnaire::TernaryStrengthAnalysis.new(6,6,"Prosoziales Verhalten",value, left_maximum: 5, right_minimum: 10)
      end
      analyses
    end

  end
end
