# short explanation: this is a workaround.
# invoking pdfkit results in an error like the following on *some* systems
#
# No wkhtmltopdf executable found at
# >> Please install wkhtmltopdf - https://github.com/pdfkit/PDFKit/wiki/Installing-WKHTMLTOPDF
#
# The actual executable is empty ( found at ______ ) but wkhtmltopdf is installed via bundler
# and available in vendor gem directory on all affected systems.
# Direct invocation on commandline is also successful.
# As we cannot track down the actual reason for this, there is still the option to configure a wrapper
# script which invokes 'bundle exec wkhtmltopdf' and passes all arguments through.
PDFKit.configure do |config|
  config.wkhtmltopdf = File.join(Rails.root, "lib", "wkhtmltopdf.sh")
end
