class CreateDiagnosticBorrows < ActiveRecord::Migration
  def change
    create_table :diagnostic_borrows do |t|
      t.references :diagnostic, index: true, foreign_key: true
      t.references :teacher, index: true, foreign_key: true
      t.references :institution, index: true, foreign_key: true
      t.date :from_date
      t.date :to_date
      t.timestamps null: false
    end

    create_table :advancement_plan_borrows do |t|
      t.references :advancement_plan, index: {name: 'idx_apb_on_ap_id'}, foreign_key: true
      t.references :teacher, index: true, foreign_key: true
      t.references :institution, index: true, foreign_key: true
      t.date :from_date
      t.date :to_date
      t.timestamps null: false
    end

    remove_column :advancement_plan_institution_stocks, :borrowed
    remove_column :diagnostic_institution_stocks, :borrowed
  end
end
