class AuthorizationTasks < ActiveRecord::Migration
  def up
    add_column :auth_roles, :is_default_role, :boolean
    execute <<-SQL
      DELETE FROM auth_items_roles WHERE NOT EXISTS (SELECT 1 FROM auth_items WHERE auth_items.id=auth_items_roles.auth_item_id);
      DELETE FROM auth_roles WHERE user_type IN ('Client','Supporter','Guardian'); -- they cannot have accoutn right now
      UPDATE auth_roles SET is_default_role=true;
      INSERT INTO auth_roles_users (user_id,auth_role_id) SELECT users.id,auth_roles.id FROM users
      join auth_roles on users.identifiable_type=auth_roles.user_type;
    SQL
    add_column :auth_items, :is_default_item, :boolean, default: false
    add_column :auth_items, :is_su_item, :boolean, default: true
  end
  def down
    remove_column :auth_roles, :is_default_role
    remove_column :auth_items, :is_su_item
    remove_column :auth_items, :is_default_item
    execute <<-SQL
       DELETE FROM auth_roles_users;
    SQL
    # everything else is gone gone :)
  end
end
