class AddDiagnosticSettingsToPortfolioItem < ActiveRecord::Migration
  def change
    add_column :portfolio_items, :is_range_okologie, :boolean, default: false
    add_column :portfolio_items, :is_range_integration, :boolean, default: false
    add_column :portfolio_items, :is_range_intensitaet, :boolean, default: false

    add_column :portfolio_specializations, :specialization_type, :string, default: nil
    PortfolioSpecialization.where(abbreviation: 'ESE').update_all(specialization_type: 'ese')
    PortfolioSpecialization.where(abbreviation: 'LE').update_all(specialization_type: 'le')
    PortfolioSpecialization.where(abbreviation: 'SQ').update_all(specialization_type: 'sq')
    PortfolioSpecialization.where(abbreviation: 'GE').update_all(specialization_type: 'ge')
    PortfolioSpecialization.where(abbreviation: 'KmE').update_all(specialization_type: 'kme')
    PortfolioSpecialization.where(abbreviation: 'HK').update_all(specialization_type: 'hk')
    PortfolioSpecialization.where(abbreviation: 'SE').update_all(specialization_type: 'se')

    create_table :diagnostics_portfolio_specializations, id: false do |t|
      t.references :diagnostic, null: false
      t.references :portfolio_specialization, null: false
    end

  end
end
