class AddDbrc < ActiveRecord::Migration
  def change
    create_table :portfolio_dbrcs do |t|
      t.references :portfolio_item, null: false, index: true
      t.references :client, null: false, index: true
      t.references :questionnaire, null: true, index: true
      t.references :questionnaire_result, null: true, index: true
    end
    add_foreign_key :portfolio_dbrcs, :portfolio_items, on_delete: :cascade, on_update: :cascade
    add_foreign_key :portfolio_dbrcs, :clients, on_delete: :cascade, on_update: :cascade
    add_foreign_key :portfolio_dbrcs, :questionnaires, on_delete: :nullify, on_update: :cascade
    add_foreign_key :portfolio_dbrcs, :questionnaire_results, on_delete: :nullify, on_update: :cascade

    add_reference :portfolio_item_targets, :portfolio_dbrc, null: true, index: true
    add_foreign_key :portfolio_item_targets, :portfolio_dbrcs, on_delete: :cascade, on_update: :cascade

    add_column :portfolio_item_targets, :drc_item_id, :integer, null: true
  end
end
