class TeacherConstraints < ActiveRecord::Migration
  def change
    begin
      remove_foreign_key :questionnaires, :teachers
    rescue ArgumentError
    end  
    add_foreign_key :questionnaires, :teachers, on_delete: :nullify, on_update: :cascade

    begin
      remove_foreign_key :clients, :teachers
    rescue ArgumentError
    end
    add_foreign_key :clients, :teachers, on_delete: :nullify, on_update: :cascade

    begin
      remove_foreign_key :advancement_plan_borrows, :teachers
    rescue ArgumentError
    end
    add_foreign_key :advancement_plan_borrows, :teachers, on_delete: :cascade, on_update: :cascade

    begin
      remove_foreign_key :diagnostic_borrows, :teachers
    rescue ArgumentError
    end
    add_foreign_key :diagnostic_borrows, :teachers, on_delete: :cascade, on_update: :cascade

    begin
      remove_foreign_key :client_group_histories, :teachers
    rescue ArgumentError
    end
    add_foreign_key :client_group_histories, :teachers, on_delete: :nullify, on_update: :cascade

    begin
      remove_foreign_key :client_groups, :teachers
    rescue ArgumentError
    end
    add_foreign_key :client_groups, :teachers, on_delete: :nullify, on_update: :cascade

  end
end
