# encoding: UTF-8
# This file is NOT auto-generated from the current state of the database. Instead
# it is edited when new migrations are added that contain statements that are not
# automatically included in schema.rb
#
#
# It's strongly recommended that you check this file into your version control system.
################################################################################
#
# THE MIGRATION TIMESTAMP OF THE LATEST MIGRATION THAT IS COVERED IN THIS FILE
#
# --------------------------
# @@VERSION : 2017067125042
# --------------------------
#
################################################################################
ActiveRecord::Schema.define do
  enable_extension "plpgsql"
  # ------------------------------------------------
  # 2017067125042_alter_instituiton_hierarchies_trigger.rb
  # ------------------------------------------------
  execute 'WITH RECURSIVE institution_hierarchies_cte(child_id,parent_id) AS (
      SELECT institutions.id, institutions.parent_id
      FROM institutions WHERE  institutions.parent_id IS NOT NULL
      UNION
      SELECT institution_hierarchies_cte.child_id, institutions.parent_id
      FROM institution_hierarchies_cte JOIN institutions  ON institution_hierarchies_cte.parent_id = institutions.id
      WHERE institutions.parent_id IS NOT NULL
    )  INSERT INTO institution_hierarchies SELECT institution_hierarchies_cte.parent_id,institution_hierarchies_cte.child_id FROM institution_hierarchies_cte;'
  execute "
      CREATE OR REPLACE FUNCTION institution_hierarchies_update() RETURNS TRIGGER
      AS $institution_hierarchies_update$
          BEGIN
              IF (TG_OP = 'DELETE') THEN
                DELETE FROM institution_hierarchies WHERE child_id=OLD.id OR parent_id=OLD.id;
                UPDATE institutions SET parent_id=OLD.parent_id WHERE parent_id=OLD.id;
              ELSIF (TG_OP = 'UPDATE') THEN
                -- Rebuild the complete hierarchy, consider rebuilding partly when performance degrades
                DELETE FROM institution_hierarchies;
                WITH RECURSIVE institution_hierarchies_cte(child_id,parent_id) AS (
                  SELECT institutions.id, institutions.parent_id
                  FROM institutions WHERE  institutions.parent_id IS NOT NULL
                  UNION
                  SELECT institution_hierarchies_cte.child_id,  institutions.parent_id
                  FROM institution_hierarchies_cte JOIN institutions  ON institution_hierarchies_cte.parent_id = institutions.id
                  WHERE institutions.parent_id IS NOT NULL
                )  INSERT INTO institution_hierarchies (parent_id,child_id) SELECT institution_hierarchies_cte.parent_id,institution_hierarchies_cte.child_id FROM institution_hierarchies_cte;
              ELSIF (TG_OP = 'INSERT') THEN
                -- Rebuild the complete hierarchy, consider rebuilding partly when performance degrades
                DELETE FROM institution_hierarchies;
                WITH RECURSIVE institution_hierarchies_cte(child_id,parent_id) AS (
                  SELECT institutions.id, institutions.parent_id
                  FROM institutions WHERE  institutions.parent_id IS NOT NULL
                  UNION
                  SELECT institution_hierarchies_cte.child_id,  institutions.parent_id
                  FROM institution_hierarchies_cte JOIN institutions  ON institution_hierarchies_cte.parent_id = institutions.id
                  WHERE institutions.parent_id IS NOT NULL
                )  INSERT INTO institution_hierarchies (parent_id,child_id) SELECT institution_hierarchies_cte.parent_id,institution_hierarchies_cte.child_id FROM institution_hierarchies_cte;
              END IF;
              RETURN NULL;
          END;
      $institution_hierarchies_update$ LANGUAGE plpgsql;
      CREATE TRIGGER institutions_maintain_tree_consistency
      AFTER INSERT OR UPDATE OR DELETE ON institutions
          FOR EACH ROW EXECUTE PROCEDURE institution_hierarchies_update();"

  # ------------------------------------------------
  # 20170320101629_add_queue_classic.rb
  # ------------------------------------------------
  execute(File.read( QC::Setup::SqlFunctions))

end
