desc "Creates nondigest versions of ckeditor assets"
require 'fileutils'
task 'ckeditor:create_nondigest_assets' do
  fingerprint = /\-[0-9a-f]{64}\./
  for file in Dir["public/assets/ckeditor/**/*"]
    next unless file =~ fingerprint
    nondigest = file.sub fingerprint, '.'
    FileUtils.cp file, nondigest, verbose: true
  end
end
Rake::Task['assets:precompile'].enhance do
  Rake::Task['ckeditor:create_nondigest_assets'].invoke
end

